import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.util.ArrayList;
import java.util.Scanner;

import scd.common.CommonUtils;

public class ProcessData {
	public static void main(String[] args) {
		try {
			String fileIn = args[0];
			String fileOut = args[1];
			if (args.length == 2) {
				generateChangePoints(fileIn, fileOut);
			} else {
				CommonUtils.normalizeData(fileIn, fileOut, Integer.parseInt(args[2]));
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	private static void generateChangePoints(String fileIn, String fileOut) throws Exception {
		Scanner scan = new Scanner(new File(fileIn));
		BufferedWriter writer = new BufferedWriter(new FileWriter(new File(fileOut)));
		String s = null;
		String[] vals = null;
		String label = "";
		while (scan.hasNext()) {
			s = scan.nextLine();
			vals = s.split(",");
			
			if (label.equals("")) {
				label = vals[vals.length - 1];
				vals[vals.length - 1] = "0";
			} else {
				if (vals[vals.length - 1].equals(label)) {
					vals[vals.length - 1] = "0";
				} else {
					label = vals[vals.length - 1];
					vals[vals.length - 1] = "1";
				}
			}
			
			for (int i = 0; i < vals.length; i++) {
				if (i == 0) {
					writer.write(vals[i]);
				} else {
					writer.write("," + vals[i]);
				}
			}
			
			writer.newLine();
		}
		scan.close();
		writer.flush();
		writer.close();
	}
	
	public static ArrayList<Integer> generateChangePoints(ArrayList<Integer> labels) throws Exception {
		int label = -1;
		ArrayList<Integer> ret = new ArrayList<Integer>();
		for (int v : labels) {
			if (label == -1) {
				label = v;
				ret.add(0);
			} else {
				if (v == label) {
					ret.add(0);
				} else {
					label = v;
					ret.add(1);
				}
			}
		}
		return ret;
	}
}