import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.util.ArrayList;

import sca.detection.ChangeDetection;
import scd.common.CommonUtils;
import scd.constants.Constants;

public class Test {
	public static void main(String[] args) {
		try {
			CommonUtils.readInputString(args);
			ArrayList<Integer> labels = new ArrayList<Integer>();
			ArrayList<double[]> data = CommonUtils.readData(Constants.FILEIN, Constants.DIM, labels);
			long start = System.currentTimeMillis();
			double[] results = ChangeDetection.detection(data, labels, Constants.WSIZE, Constants.DIM, Constants.SUBDIM);
			long end = System.currentTimeMillis();
			
			BufferedWriter writer = new BufferedWriter(new FileWriter(new File(Constants.FILEOUT)));
			writer.write(String.format("TP = %f", results[0]));
			writer.newLine();
			writer.write(String.format("FP = %f", results[1]));
			writer.newLine();
			writer.write(String.format("FN = %f", results[2]));
			writer.newLine();
			writer.write(String.format("LR = %f", results[3]));
			writer.newLine();
			writer.write(String.format("F1 = %f", results[4]));
			writer.newLine();
			writer.write(Long.toString(end - start));
			writer.flush();
			writer.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
}