import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashSet;
import java.util.Scanner;

public class YoutubeData {
	public static void main(String[] args) {
		try {
			//combine();
			produceFinalData();
			//producePointIDs();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	private static void createData() throws Exception {
		ArrayList<String> srcFileNames = read("H:\\Development\\SCD\\SCD\\data\\youtube\\names.txt");
		String dir = "H:\\Development\\SCD\\SCD\\data\\youtube\\dir_data";
		
		//int nLabel = 31;
		//int n = 10000;
		
		String prefix = "train";
		createData(dir + "\\" + prefix, srcFileNames);
		
		prefix = "validation";
		createData(dir + "\\" + prefix, srcFileNames);
		
		prefix = "test";
		createData(dir + "\\" + prefix, srcFileNames);
	}
	
	private static void produceFinalData() throws Exception {
		BufferedWriter writer = new BufferedWriter(new FileWriter(new File("H:\\Development\\SCD\\SCD\\data\\youtube\\youtubeFinal.txt")));
		int n = 20000;
		String label = null;
		for (int i = 1; i <= 31; i++) {
			label = Integer.toString(i);
			Scanner scan = new Scanner(new File("H:\\Development\\SCD\\SCD\\data\\youtube\\youtube" + label + ".txt"));
			String s = null;
			String[] vals = null;
			double[] data = new double[n];
			int attID;
			//int idx = 0;
			while (scan.hasNext()) {
				s = scan.nextLine();
				if (s.isEmpty()) {
					break;
				}
				
				vals = s.split(",");
				if (!vals[vals.length - 1].equals(label)) {
					continue;
				}
				
				for (int j = 0; j < vals.length - 1; j++) {
					attID = Integer.parseInt(vals[j].split(":")[0]) - 1;
					if (attID < n) {
						data[attID] = Double.parseDouble(vals[j].split(":")[1]);
					}
				}
				
				for (int j = 0; j < n; j++) {
					writer.write(Double.toString(data[j]) + ",");
				}
				writer.write(label);
				writer.newLine();
				//idx++;
				//System.out.printf("idx = %d\n", idx);
			}
			scan.close();
			System.out.printf("label = %d\n\n", i);
		}
		writer.flush();
		writer.close();
	}
	
	private static void combine() throws Exception {
		ArrayList<String> ids = read("H:\\Development\\SCD\\SCD\\data\\youtube\\ids.txt");
		String[] vals = null;
		for (String id : ids) {
			Scanner scan = new Scanner(new File("H:\\Development\\SCD\\SCD\\data\\youtube\\" + id + ".txt"));
			vals = scan.nextLine().split(",");
			scan.close();
			
			BufferedWriter writer = new BufferedWriter(new FileWriter(new File("H:\\Development\\SCD\\SCD\\data\\youtube\\youtube" + vals[0] + ".txt"), true));
			for (int i = 1; i < vals.length; i++) {
				writer.write(vals[i] + ",");
			}
			writer.write(vals[0]);
			writer.newLine();
			writer.flush();
			writer.close();
		}
	}
	
	private static ArrayList<String> read(String file) throws Exception {
		Scanner scan = new Scanner(new File(file));
		ArrayList<String> out = new ArrayList<String>();
		while (scan.hasNext()) {
			out.add(scan.nextLine());
		}
		scan.close();
		
		return out;
	}
	
	private static void producePointIDs() throws Exception {
		HashSet<Integer> ids = new HashSet<Integer>();
		String dir = "H:\\Development\\SCD\\SCD\\data\\youtube\\dir_data";
		
		String prefix = "train";
		producePointIDs(dir + "\\" + prefix, ids);
		
		prefix = "validation";
		producePointIDs(dir + "\\" + prefix, ids);
		
		prefix = "test";
		producePointIDs(dir + "\\" + prefix, ids);
		
		String fileOut = "H:\\Development\\SCD\\SCD\\data\\youtube\\ids.txt";
		BufferedWriter writer = new BufferedWriter(new FileWriter(new File(fileOut)));
		Integer[] a = new Integer[ids.size()];
		a = ids.toArray(a);
		Arrays.sort(a);
		for (int v : a) {
			writer.write(Integer.toString(v));
			writer.newLine();
		}
		writer.flush();
		writer.close();
	}
	
	private static void producePointIDs(String dir, HashSet<Integer> ids) throws Exception {
		File folder = new File(dir);
		for (File fileEntry : folder.listFiles()) {
	        Scanner scan = new Scanner(fileEntry);
	        String s = null;
	        while (scan.hasNext()) {
	        	s = scan.nextLine();
	        	
	        	if (s.isEmpty()) {
	        		break;
	        	}
	        	
	        	if (s.startsWith("#")) {
	        		ids.add(Integer.parseInt(s.split("\t")[1]));
	        	}
	        }
	        scan.close();
		}
	}
	
	public static void createData(String dir, ArrayList<String> srcFileNames) throws Exception {
		File folder = new File(dir);
		String newDir = "H:\\Development\\SCD\\SCD\\data\\youtube";
		for (String fileName : srcFileNames) {
	        Scanner scan = new Scanner(new File(folder + "\\" + fileName + ".txt"));
	        String s1 = null, s2 = null;
	        File f = null;
	        BufferedWriter writer = null;
	        String[] vals = null;
	        boolean exists;
	        int id;
	        while (scan.hasNext()) {
	        	s1 = scan.nextLine();
	        	if (s1.isEmpty()) {
	        		break;
	        	}
	        	id = Integer.parseInt(s1.split("\t")[1]);
	        	f = new File(newDir + "\\" + Integer.toString(id) + ".txt");
	        	if (f.exists()) {
	        		writer = new BufferedWriter(new FileWriter(f, true));
	        		exists = true;
	        	} else {
	        		writer = new BufferedWriter(new FileWriter(f));
	        		exists = false;
	        	}
	        	
	        	s2 = scan.nextLine();
	        	vals = s2.split(" ");
	        	
	        	if (!exists) {
	        		writer.write(vals[0]);
	        	}
	        	for (int i = 1; i < vals.length; i++) {
	        		writer.write("," + vals[i]);
	        	}
	        	writer.flush();
	    		writer.close();
	        }
	        scan.close();
	    }
	}
}